Program mon_pent;
uses crt;
const
     hex_tabl:array[0..15] of char='0123456789ABCDEF';
     up=#72;
     down=#80;
     count = 14;
     lenght = 44;
     f1 = #59;

type
    PEl = ^TEl;
    TEl = record
        name : string;
        next : pel;
    end;

    TMenu=record
         n : integer;
         length : word;
         current : word;
         first : pel;
         last : pel;
    end;

var
   i      ,
   b      ,
   es0    ,
   cc0    ,
   es1    ,
   cc1    : byte;
   e1     ,
   e2     ,
   f      : extended;
   cesr   ,
   cesr1  ,
   cesr2  ,
   data1  ,
   data2  ,
   cx_11h ,
   cx_12h : longint;
   menu   : TMenu;
   tmp    : Pel;
   a      : Byte;

function hex(p:longint):string;
var
   s:string;
   begin
        s:='h';
   repeat
         s:=hex_tabl[p and $f]+s;
         p:=p shr 4
   until p=0;
   hex:=s
end;

procedure drawEl(sEl: integer);
var
   i,k:word;
begin
     tmp:=menu.first;
     for i:=1 to sEl do
         tmp:=tmp^.next;
     gotoXY((80-menu.length) div 2-1,5);
     write('');
     for i:=1 to menu.length do
         write('');
     writeln('');
     for k:=1 to 14 do
         begin
              if k>menu.n then break;
              gotoXY((80-menu.length) div 2-1,5+k);
              write('');
              for i:=1 to menu.length do
              write(' ');
              gotoXY((80-menu.length) div 2+1,5+k);
              gotoXY((80-menu.length) div 2+(menu.length-length(tmp^.name)) div 2,5+k);
              write(tmp^.name);
              gotoXY((80-menu.length) div 2+menu.length,5+k);
              writeln('');
              tmp:=tmp^.next;
         end;
     gotoXY((80-menu.length) div 2-1,5+k);
     write('');
     for i:=1 to menu.length do
         write('');
     writeln('');
end;

procedure deleteCursor;assembler;
asm
    mov ah, 1h
    mov ch, 20h
    int 10h
end;

procedure setCursor;assembler;
asm
    mov ah, 1h
    mov cx, 3342
    int 10h
end;

procedure makemenu;
var
   f : text;
   s : string;
   tmp : pEl;
begin
     textcolor(15);
     assign(f,'ftxt.txt');
     reset(f);
     menu.n:=0;
     menu.current:=1;
     while not EOF(f) do
           begin
                menu.n:=menu.n+1;
                new(tmp);
                readln(f,s);
                tmp^.name:=s;
                tmp^.next:=nil;
                if menu.first=nil
                   then
                    begin
                        menu.first:=tmp;
                        menu.last:=tmp;
                        menu.length:=length(s)+2;
                    end
                   else
                        menu.last^.next:=tmp;
                if menu.length<length(s)+2 then menu.length:=length(s)+2;
                if menu.length>70 then menu.length:=70;
                menu.last:=tmp;
           end;
     close(f);
     drawEl(0);
end;

function selectitem:byte;
 var ch : char;
     fh : text;
     sh : string;
     item : byte;
     list : byte;
     vbuf : array [1..80*25*2] of byte absolute $b800:0;
     refresh : boolean;
     n,e : integer;
     procedure mark(color:byte);
     var i:byte;
         w_item:byte;
     begin
     if item>13 then item:=13
                else w_item:=item;
     for i:=1 to menu.length do
     vbuf[(5+(w_item-1))*80*2+((80-menu.length) div 2-1+i)*2]:=color;
end;
    begin
    assign(fh,'help.txt');
    deletecursor;
    ch:=#0;
    item:=1;
    list:=1;
    mark($20);
    repeat
    ch:=readkey;
    if ch=#0 then
             begin
              ch:=readkey;
              case ch of
               up :begin
                    mark($F);
                    dec(item);
                    if item<1 then item:=1;
                    if item>=13 then drawEl(item-13);
                    mark($20);
                   end;
               down : begin
                       mark($F);
                       inc(item);
                       if item>78 then item:=78;
                       if item>=13 then drawEl(item-13);
                       mark($20);
                      end;
               f1 : begin
                     reset(fh);
                     while not EOF(fh) do
                      begin
                       readln(fh,sh);
                       if sh[1]='&' then
                                     begin
                                      delete(sh,1,1);
                                      delete(sh,length(sh)-2,2);
                                     end;
                       val(sh,n,e);
                       if n=item then
                                  begin
                                   clrscr;
                                   readln(fh,sh);
                                   mark($F);
                                   repeat
                                    writeln(sh);
                                    readln(fh,sh);
                                   until sh[1]='&';
                    readkey;
                    clrscr;
                    if item>=13 then drawEl(item-13)
                                else drawEl(1);
                    mark($20);
                    break;
                    close(fh);
                                  end;
                      end;
                    end;
              end;
             end;
    until ch in [#13,#32];
    setcursor;
    clrscr;
    selectitem:=item;
    end;
begin
     setcursor;
     makemenu;
     deletecursor;
     a:= selectitem;
     ClrScr;
     es0:=a;
     cc0:=3;
     es1:=0;
     cc1:=0;
     cesr:=0;
     cesr:=es0+cc0 shl 6;
     cesr1:=es0+cc0 shl 6+es1 shl 16+cc1 shl 22;
     cesr2:=3;
     cx_12h:=$12;
     cx_11h:=$11;
     asm
        db 66h
        xor dx,dx
        db 66h
        xor ax,ax
        db 66h
        mov cx,word ptr cx_12h
        db 0fh,30h
        db 66h
        xor ax,ax
        db 66h
        db 66h
        xor dx,dx
        db 66h
        mov ax,word ptr cesr1
        db 66h
        mov cx,word ptr cx_11h
        db 0fh,30h
        mov cx,$77
   @1:  mov ax,ds
        mov ds,ax
        loop @1
        db 66h
        mov ax,word ptr cesr2
        db 66h
        xor dx,dx
        db 66h
        mov cx,word ptr cx_11h
        db 0fh,30h
        mov cx,word ptr cx_12h
        db 0fh,32h
        db 66h
        mov word ptr data2,dx
        db 66h
        mov word ptr data1,ax
        end;
        writeln ('i稫쭨  祭  = ',hex(data2),' ',hex(data1));
end.